diff --git a/.gitignore b/.gitignore
index da66d74a9..ec4326404 100644
--- a/.gitignore
+++ b/.gitignore
@@ -18,3 +18,4 @@ src/main/java/net/minecraft/core/Version.java
 BiomeLookup.png
 version.txt
 log4j.properties
+/generated/
diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index 9629d8876..c9aa34865 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -256,6 +256,8 @@ public class Minecraft
     public GameWindow gameWindow;
     public ClientSkinVariantList skinVariantList = new ClientSkinVariantList(this);
     public MainMenuBackground mainMenuBackground = new MainMenuBackground(this);
+    public @Nullable Integer overrideWidth = null;
+    public @Nullable Integer overrideHeight = null;
     /**
      * Do not display the ingame crash handler until this is set to true
      */
@@ -420,7 +422,7 @@ public class Minecraft
 
 		printWrongJavaVersionInfo();
 		
-		gameWindow.init(this, gameSettings.windowWidth.value, gameSettings.windowHeight.value);
+		gameWindow.init(this, overrideWidth != null ? overrideWidth : gameSettings.windowWidth.value, overrideHeight != null ? overrideHeight : gameSettings.windowHeight.value);
 
         LOGGER.info("Resolution: {} x {}", gameWindow.getWidthPixels(), gameWindow.getHeightPixels());
 
@@ -2485,7 +2487,7 @@ public class Minecraft
         this.renderer.reload();
     }
 
-    public static void startMainThread(String username, String sessionId, String uuid)
+    public static void startMainThread(@Nullable String username, @Nullable String sessionId, @Nullable String uuid, @Nullable String server, @Nullable Integer port, @Nullable Integer width, @Nullable Integer height)
     {
         GameWindow gameWindow = new GameWindowGLFW();
         Minecraft mc = new Minecraft(gameWindow);
@@ -2506,6 +2508,15 @@ public class Minecraft
         username = username == null ? "Player" + System.currentTimeMillis() % 1000L : username;
 
         mc.session = new Session(username, uuid, sessionId);
+        if (server != null) {
+            mc.setServer(server, port == null ? 25565 : port);
+        }
+        if (width != null) {
+            mc.overrideWidth = width;
+        }
+        if (height != null) {
+            mc.overrideHeight = height;
+        }
         mc.run();
     }
 
@@ -2515,6 +2526,10 @@ public class Minecraft
         String sessionId = null;
         String gameDirectory = null;
         String uuid = null;
+        String server = null;
+        Integer port = null;
+        Integer width = null;
+        Integer height = null;
 
         int pointer = 0;
         while (pointer < args.length) {
@@ -2559,11 +2574,51 @@ public class Minecraft
                     pointer++;
                     break;
                 }
+                case "--server": {
+                    try {
+                        server = args[pointer + 1];
+                        pointer++;
+                    } catch (Exception e) {
+                        e.printStackTrace();
+                    }
+                    pointer++;
+                    break;
+                }
+                case "--port": {
+                    try {
+                        port = Integer.parseInt(args[pointer + 1]);
+                        pointer++;
+                    } catch (Exception e) {
+                        e.printStackTrace();
+                    }
+                    pointer++;
+                    break;
+                }
+                case "--width": {
+                    try {
+                        width = Integer.parseInt(args[pointer + 1]);
+                        pointer++;
+                    } catch (Exception e) {
+                        e.printStackTrace();
+                    }
+                    pointer++;
+                    break;
+                }
+                case "--height": {
+                    try {
+                        height = Integer.parseInt(args[pointer + 1]);
+                        pointer++;
+                    } catch (Exception e) {
+                        e.printStackTrace();
+                    }
+                    pointer++;
+                    break;
+                }
                 default:
                     pointer++;
             }
         }
-        startMainThread(playerName, sessionId, uuid);
+        startMainThread(playerName, sessionId, uuid, server, port, width, height);
     }
     
     public void setInputType(InputType inputType) {
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java b/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java
index ee9512c2e..dec58e21e 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java
@@ -9,15 +9,32 @@ import net.minecraft.client.gui.guidebook.GuidebookSection;
 import net.minecraft.client.gui.guidebook.GuidebookSections;
 import net.minecraft.client.gui.guidebook.PageManager;
 import net.minecraft.client.gui.guidebook.RecipePage;
+import net.minecraft.client.gui.guidebook.crafting.displays.LabelDisplayAdapter;
+import net.minecraft.client.gui.guidebook.crafting.displays.LabelDyeDisplayAdapter;
+import net.minecraft.client.gui.guidebook.crafting.displays.MapDuplicationDisplayAdapter;
+import net.minecraft.client.gui.guidebook.crafting.displays.RecipeDisplayAdapter;
+import net.minecraft.client.gui.guidebook.crafting.displays.RepairableDisplayAdapter;
+import net.minecraft.client.gui.guidebook.crafting.displays.ScrapDisplayAdapter;
+import net.minecraft.client.gui.guidebook.crafting.displays.ShapedDisplayAdapter;
+import net.minecraft.client.gui.guidebook.crafting.displays.ShapelessDisplayAdapter;
+import net.minecraft.client.gui.guidebook.crafting.displays.ToolDisplayAdapter;
+import net.minecraft.client.gui.guidebook.crafting.displays.UndyeDisplayAdapter;
 import net.minecraft.client.gui.guidebook.search.SearchPage;
 import net.minecraft.client.render.Font;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.core.achievement.Achievements;
-import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCrafting;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShaped;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShapeless;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingWithTool;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryLabel;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryLabelDye;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryMapDuplication;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryRepairable;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryScrap;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryUndyeing;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.client.gui.guidebook.GuidebookSlot;
@@ -35,6 +52,21 @@ public class CraftingPage
 
     public List<GuidebookSlot> slots;
     public Map<RecipeEntryCrafting<?,?>,List<GuidebookSlot>> map;
+
+    public static Map<Class<? extends RecipeEntryCrafting<?, ?>>, RecipeDisplayAdapter<?>> recipeToDisplayAdapterMap = new HashMap<>();
+
+    static {
+        recipeToDisplayAdapterMap.put(RecipeEntryCraftingShaped.class, new ShapedDisplayAdapter());
+        recipeToDisplayAdapterMap.put(RecipeEntryCraftingShapeless.class, new ShapelessDisplayAdapter());
+        recipeToDisplayAdapterMap.put(RecipeEntryCraftingWithTool.class, new ToolDisplayAdapter());
+        recipeToDisplayAdapterMap.put(RecipeEntryRepairable.class, new RepairableDisplayAdapter());
+        recipeToDisplayAdapterMap.put(RecipeEntryScrap.class, new ScrapDisplayAdapter());
+        recipeToDisplayAdapterMap.put(RecipeEntryLabel.class, new LabelDisplayAdapter());
+        recipeToDisplayAdapterMap.put(RecipeEntryLabelDye.class, new LabelDyeDisplayAdapter());
+        recipeToDisplayAdapterMap.put(RecipeEntryMapDuplication.class, new MapDuplicationDisplayAdapter());
+        recipeToDisplayAdapterMap.put(RecipeEntryUndyeing.class, new UndyeDisplayAdapter());
+    }
+
     private final TooltipElement tooltipElement;
     private final ItemElement itemElement;
     private static final Minecraft mc = Minecraft.getMinecraft(GuidebookPage.class);
@@ -54,117 +86,12 @@ public class CraftingPage
         int xOffset = 32;
         int yOffset = 12;
         for (RecipeEntryCrafting<?,?> recipe : recipes) {
-            List<GuidebookSlot> recipeSlots = new ArrayList<>();
-            if (recipe instanceof RecipeEntryCraftingShaped)
-            {
-                final RecipeEntryCraftingShaped r = (RecipeEntryCraftingShaped) recipe;
-                int slotsAmount;
-
-                if (r.recipeHeight > 2 || r.recipeWidth > 2)
-                {
-                    slotsAmount = 10;
-
-                    for (int i = 0; i < slotsAmount - 1; i++)
-                    {
-                        final int slotX = i % 3;
-                        final int slotY = i / 3;
-
-                        if (slotX >= r.recipeWidth || slotY >= r.recipeHeight)
-                        {
-                            recipeSlots.add(new GuidebookSlot(i, 1 + 18 * (i % 3) + xOffset, 1 + 18 * ((i / 3)+recipeAmount*3) + yOffset, null, false,recipe));
-                        }
-                        else
-                        {
-                            RecipeSymbol stack = r.getInput()[slotX + (slotY * r.recipeWidth)];
-                            recipeSlots.add(new GuidebookSlot(i, 1 + 18 * (i % 3) + xOffset, 1 + 18 * ((i / 3)+recipeAmount*3) + yOffset, stack, false,recipe));
-                        }
-                    }
-
-                    int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-8).y) / 2;
-                    recipeSlots.add(new GuidebookSlot(slotsAmount - 1, 81 + xOffset, centerY, new RecipeSymbol(r.getOutput().copy()), false,recipe).setAsOutput());
-
-                    map.put(recipe,recipeSlots);
-                    slots.addAll(recipeSlots);
-                    yOffset += 10;
-                }
-                else
-                {
-                    slotsAmount = 5;
-
-
-                    for (int i = 0; i < slotsAmount - 1; i++)
-                    {
-                        final int slotX = i % 2;
-                        final int slotY = i / 2;
-
-                        if (slotX >= r.recipeWidth || slotY >= r.recipeHeight)
-                        {
-                            recipeSlots.add(new GuidebookSlot(i, 13 + 18 * (i % 2) + xOffset, 10 + 18 * ((i / 2)+recipeAmount*3) + yOffset, null, false,recipe));
-                        }
-                        else
-                        {
-                            RecipeSymbol stack = r.getInput()[slotX + (slotY * r.recipeWidth)];
-                            recipeSlots.add(new GuidebookSlot(i, 13 + 18 * (i % 2) + xOffset, 10 + 18 * ((i / 2)+recipeAmount*3) + yOffset, stack, false,recipe));
-                        }
-                    }
-
-                    int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-3).y) / 2;
-                    recipeSlots.add(new GuidebookSlot(slotsAmount - 1, 81 + xOffset, centerY, new RecipeSymbol(r.getOutput()), false,recipe).setAsOutput());
-
-                    map.put(recipe,recipeSlots);
-                    slots.addAll(recipeSlots);
-                    yOffset += 10;
-                }
-                recipeAmount++;
-            }
-            else if (recipe instanceof RecipeEntryCraftingShapeless)
-            {
-                final RecipeEntryCraftingShapeless r = (RecipeEntryCraftingShapeless) recipe;
-                int slotsAmount = 0;
-
-                if (r.getInput().size() > 4)
-                {
-                    slotsAmount = 10;
-
-
-                    for (int i = 0; i < Math.max(r.getInput().size(),9); i++)
-                    {
-                        if(i >= r.getInput().size()){
-                            recipeSlots.add(new GuidebookSlot(i, 1 + 18 * (i % 3) + xOffset, 1 + 18 * ((i / 3)+recipeAmount*3) + yOffset, null, false,recipe));
-                            continue;
-                        }
-                        RecipeSymbol stack = r.getInput().get(i);
-                        recipeSlots.add(new GuidebookSlot(i, 1 + 18 * (i % 3) + xOffset, 1 + 18 * ((i / 3)+recipeAmount*3) + yOffset, stack, false,recipe));
-                    }
-
-                    int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-8).y) / 2;
-                    recipeSlots.add(new GuidebookSlot(slotsAmount - 1, 81 + xOffset, centerY, new RecipeSymbol(r.getOutput()), false,recipe).setAsOutput());
-
-                    map.put(recipe,recipeSlots);
-                    slots.addAll(recipeSlots);
-                    yOffset += 10;
-                }
-                else
-                {
-                    slotsAmount = 5;
-
-                    for (int i = 0; i < Math.max(r.getInput().size(),4); i++)
-                    {
-                        if(i >= r.getInput().size()){
-                            recipeSlots.add(new GuidebookSlot(i, 13 + 18 * (i % 2) + xOffset, 10 + 18 * ((i / 2)+recipeAmount*3) + yOffset, null, false,recipe));
-                            continue;
-                        }
-                        RecipeSymbol stack = r.getInput().get(i);
-                        recipeSlots.add(new GuidebookSlot(i, 13 + 18 * (i % 2) + xOffset, 10 + 18 * ((i / 2)+recipeAmount*3) + yOffset, stack, false,recipe));
-                    }
-
-                    int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-3).y) / 2;
-                    recipeSlots.add(new GuidebookSlot(slotsAmount - 1, 81 + xOffset, centerY, new RecipeSymbol(r.getOutput()), false,recipe).setAsOutput());
-
-                    map.put(recipe,recipeSlots);
-                    slots.addAll(recipeSlots);
-                    yOffset += 10;
-                }
+            if (recipeToDisplayAdapterMap.containsKey(recipe.getClass())) {
+                RecipeDisplayAdapter adapter = recipeToDisplayAdapterMap.get(recipe.getClass());
+                List<GuidebookSlot> recipeSlots = adapter.getSlots(recipe, recipeAmount, xOffset, yOffset);
+                map.put(recipe,recipeSlots);
+                slots.addAll(recipeSlots);
+                yOffset += 10;
                 recipeAmount++;
             }
         }
@@ -268,4 +195,8 @@ public class CraftingPage
             }
         }
     }
+
+    public static boolean guidebookSupportsRecipe(RecipeEntryBase<?, ?, ?> recipe) {
+        return recipeToDisplayAdapterMap.containsKey(recipe.getClass());
+    }
 }
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingSection.java b/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingSection.java
index 9eb0887f0..e0a985018 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingSection.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingSection.java
@@ -3,11 +3,8 @@ package net.minecraft.client.gui.guidebook.crafting;
 import net.minecraft.client.gui.guidebook.GuidebookPage;
 import net.minecraft.client.gui.guidebook.SearchableGuidebookSection;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCrafting;
-import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShaped;
-import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShapeless;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.collection.Pair;
@@ -30,7 +27,7 @@ public class CraftingSection
     public void reloadRecipes(){
         pages.clear();
         List<RecipeEntryCrafting<?, ?>> allRecipes = new ArrayList<>(Registries.RECIPES.getAllCraftingRecipes());
-        allRecipes.removeIf((R)->(!(R instanceof RecipeEntryCraftingShaped) && !(R instanceof RecipeEntryCraftingShapeless)));
+        allRecipes.removeIf((R)->(!CraftingPage.guidebookSupportsRecipe(R)));
         int totalRecipes = allRecipes.size();
         int totalPages = MathHelper.ceilInt(totalRecipes, CraftingPage.RECIPES_PER_PAGE);
         for (int i = 0; i < totalPages; i++) {
@@ -55,7 +52,7 @@ public class CraftingSection
         if(filteredPages == null || !Objects.equals(filteredPages.getLeft(), query.rawQuery)) {
             ArrayList<RecipeEntryCrafting<?, ?>> filteredRecipes = new ArrayList<>();
             List<RecipeEntryCrafting<?, ?>> allRecipes = new ArrayList<>(Registries.RECIPES.getAllCraftingRecipes());
-            allRecipes.removeIf((R)->(!(R instanceof RecipeEntryCraftingShaped) && !(R instanceof RecipeEntryCraftingShapeless)));
+            allRecipes.removeIf((R)->(!CraftingPage.guidebookSupportsRecipe(R)));
             for (RecipeEntryCrafting<?, ?> recipe : allRecipes) {
                 if(recipe.matchesQueryIgnoreExceptions(query)){
                     filteredRecipes.add(recipe);
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/LabelDisplayAdapter.java b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/LabelDisplayAdapter.java
new file mode 100644
index 000000000..db18caa3f
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/LabelDisplayAdapter.java
@@ -0,0 +1,121 @@
+package net.minecraft.client.gui.guidebook.crafting.displays;
+
+import net.minecraft.client.gui.guidebook.GuidebookSlot;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryLabel;
+import net.minecraft.core.item.IItemConvertible;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Random;
+
+public class LabelDisplayAdapter implements RecipeDisplayAdapter<RecipeEntryLabel>{
+    protected static final IItemConvertible[] randomOptions = new IItemConvertible[100];
+    public static final String[] randomNames = new String[] {"Useless", "Bob", "Steve", "Adam", "Lucas", "George", "Ferdinand", "Hemingway", "Greg", "Brian", "Fells", "Herobrine"};
+    static {
+        {
+            int blocksAdded = 0;
+            int lastId = 0;
+            int offset = 1;
+            while (blocksAdded < 50) {
+                Block b = null;
+                while (b == null) {
+                    b = Block.getBlock(lastId + offset++);
+                }
+                randomOptions[blocksAdded++] = b;
+                lastId = b.id;
+                offset = 1;
+            }
+        }
+        {
+            int itemsAdded = 0;
+            int lastId = 0;
+            int offset = 1;
+            while (itemsAdded < 50) {
+                Item b = null;
+                while (b == null) {
+                    b = Item.getItem(lastId + offset++);
+                }
+                randomOptions[50 + itemsAdded++] = b;
+                lastId = b.id;
+                offset = 1;
+            }
+        }
+    }
+    @Override
+    public List<GuidebookSlot> getSlots(RecipeEntryLabel recipe, int recipeAmount, int xOffset, int yOffset) {
+        List<GuidebookSlot> recipeSlots = new ArrayList<>();
+
+        ItemStack[] sharedBuffer = new ItemStack[2]; // 0:Label | 1:Item to name
+        RecipeSymbol[] symbols = {new RecipeSymbol(Items.LABEL.getDefaultStack()), new RecipeSymbol(randomOptions[0].getDefaultStack()), null, null, new RecipeSymbol(randomOptions[0].getDefaultStack())};
+
+        for (int i = 0; i < 4; i++) {
+            GuidebookSlot slot;
+            int x = 13 + 18 * (i % 2) + xOffset;
+            int y = 10 + 18 * ((i / 2) + recipeAmount * 3) + yOffset;
+            if (i == 0) {
+                slot = new LabelGuidebookSlot(i, x, y, symbols[i], false, recipe, sharedBuffer);
+            } else if (i == 1) {
+                slot = new UnnamedInputGuidebookSlot(i, x, y, symbols[i], false, recipe, sharedBuffer);
+            } else {
+                slot = new GuidebookSlot(i, x, y, symbols[i], false, recipe);
+            }
+            recipeSlots.add(slot);
+        }
+
+        int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-3).y) / 2;
+        recipeSlots.add(new NamedOutputGuidebookSlot(symbols.length - 1, 81 + xOffset, centerY, symbols[4], false, recipe, sharedBuffer).setAsOutput());
+        return recipeSlots;
+    }
+
+    public static class LabelGuidebookSlot extends GuidebookSlot {
+        private final ItemStack[] itemBuffer;
+        public LabelGuidebookSlot(int id, int x, int y, RecipeSymbol symbol, boolean discovered, RecipeEntryBase<?, ?, ?> recipe, ItemStack[] itemBuffer) {
+            super(id, x, y, symbol, discovered, recipe);
+            this.itemBuffer = itemBuffer;
+        }
+
+        @Override
+        public void showRandomItem() {
+            Random r = new Random();
+            item = new ItemStack(Items.LABEL);
+            itemBuffer[0] = item;
+            item.setCustomName(randomNames[r.nextInt(randomNames.length)]);
+        }
+    }
+
+    public static class UnnamedInputGuidebookSlot extends GuidebookSlot {
+        private final ItemStack[] itemBuffer;
+        public UnnamedInputGuidebookSlot(int id, int x, int y, RecipeSymbol symbol, boolean discovered, RecipeEntryBase<?, ?, ?> recipe, ItemStack[] itemBuffer) {
+            super(id, x, y, symbol, discovered, recipe);
+            this.itemBuffer = itemBuffer;
+        }
+
+        @Override
+        public void showRandomItem() {
+            Random r = new Random();
+            item = randomOptions[r.nextInt(randomOptions.length)].getDefaultStack();
+            itemBuffer[1] = item;
+        }
+    }
+
+    public static class NamedOutputGuidebookSlot extends GuidebookSlot {
+        private final ItemStack[] itemBuffer;
+        public NamedOutputGuidebookSlot(int id, int x, int y, RecipeSymbol symbol, boolean discovered, RecipeEntryBase<?, ?, ?> recipe, ItemStack[] itemBuffer) {
+            super(id, x, y, symbol, discovered, recipe);
+            this.itemBuffer = itemBuffer;
+        }
+
+        @Override
+        public void showRandomItem() {
+            item = new ItemStack(itemBuffer[1]);
+            item.setCustomName(itemBuffer[0].getCustomName());
+            item.setCustomColor(itemBuffer[0].getCustomColor());
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/LabelDyeDisplayAdapter.java b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/LabelDyeDisplayAdapter.java
new file mode 100644
index 000000000..e41eb1db1
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/LabelDyeDisplayAdapter.java
@@ -0,0 +1,88 @@
+package net.minecraft.client.gui.guidebook.crafting.displays;
+
+import net.minecraft.client.gui.guidebook.GuidebookSlot;
+import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingWithTool;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryLabelDye;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.util.helper.DyeColor;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Random;
+
+public class LabelDyeDisplayAdapter implements RecipeDisplayAdapter<RecipeEntryLabelDye> {
+    @Override
+    public List<GuidebookSlot> getSlots(RecipeEntryLabelDye recipe, int recipeAmount, int xOffset, int yOffset) {
+        List<GuidebookSlot> recipeSlots = new ArrayList<>();
+
+        ItemStack[] sharedBuffer = new ItemStack[2]; // 0:Label | 1:Dye
+        RecipeSymbol[] symbols = {new RecipeSymbol(Items.LABEL.getDefaultStack()), new RecipeSymbol(Items.DYE.getDefaultStack()), null, null, new RecipeSymbol(Items.LABEL.getDefaultStack())};
+
+        for (int i = 0; i < 4; i++) {
+            GuidebookSlot slot;
+            int x = 13 + 18 * (i % 2) + xOffset;
+            int y = 10 + 18 * ((i / 2) + recipeAmount * 3) + yOffset;
+            if (i == 0) {
+                slot = new LabelGuidebookSlot(i, x, y, symbols[i], false, recipe, sharedBuffer);
+            } else if (i == 1) {
+                slot = new DyeGuidebookSlot(i, x, y, symbols[i], false, recipe, sharedBuffer);
+            } else {
+                slot = new GuidebookSlot(i, x, y, symbols[i], false, recipe);
+            }
+            recipeSlots.add(slot);
+        }
+
+        int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-3).y) / 2;
+        recipeSlots.add(new NamedOutputGuidebookSlot(symbols.length - 1, 81 + xOffset, centerY, symbols[4], false,recipe, sharedBuffer).setAsOutput());
+        return recipeSlots;
+    }
+
+    public static class LabelGuidebookSlot extends GuidebookSlot {
+        private final ItemStack[] itemBuffer;
+        public LabelGuidebookSlot(int id, int x, int y, RecipeSymbol symbol, boolean discovered, RecipeEntryBase<?, ?, ?> recipe, ItemStack[] itemBuffer) {
+            super(id, x, y, symbol, discovered, recipe);
+            this.itemBuffer = itemBuffer;
+        }
+
+        @Override
+        public void showRandomItem() {
+            Random r = new Random();
+            item = new ItemStack(Items.LABEL);
+            itemBuffer[0] = item;
+            item.setCustomName(LabelDisplayAdapter.randomNames[r.nextInt(LabelDisplayAdapter.randomNames.length)]);
+        }
+    }
+
+    public static class DyeGuidebookSlot extends GuidebookSlot {
+        private final ItemStack[] itemBuffer;
+        public DyeGuidebookSlot(int id, int x, int y, RecipeSymbol symbol, boolean discovered, RecipeEntryBase<?, ?, ?> recipe, ItemStack[] itemBuffer) {
+            super(id, x, y, symbol, discovered, recipe);
+            this.itemBuffer = itemBuffer;
+        }
+
+        @Override
+        public void showRandomItem() {
+            Random r = new Random();
+            item = new ItemStack(Items.DYE, 1, r.nextInt(DyeColor.COLOR_AMOUNT));
+            itemBuffer[1] = item;
+        }
+    }
+
+    public static class NamedOutputGuidebookSlot extends GuidebookSlot {
+        private final ItemStack[] itemBuffer;
+        public NamedOutputGuidebookSlot(int id, int x, int y, RecipeSymbol symbol, boolean discovered, RecipeEntryBase<?, ?, ?> recipe, ItemStack[] itemBuffer) {
+            super(id, x, y, symbol, discovered, recipe);
+            this.itemBuffer = itemBuffer;
+        }
+
+        @Override
+        public void showRandomItem() {
+            item = new ItemStack(itemBuffer[0]);
+            item.setCustomName(itemBuffer[0].getCustomName());
+            item.setCustomColor((byte) (15 - itemBuffer[1].getMetadata()));
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/MapDuplicationDisplayAdapter.java b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/MapDuplicationDisplayAdapter.java
new file mode 100644
index 000000000..a6e1596e8
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/MapDuplicationDisplayAdapter.java
@@ -0,0 +1,33 @@
+package net.minecraft.client.gui.guidebook.crafting.displays;
+
+import net.minecraft.client.gui.guidebook.GuidebookSlot;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryMapDuplication;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class MapDuplicationDisplayAdapter implements RecipeDisplayAdapter<RecipeEntryMapDuplication>{
+    @Override
+    public List<GuidebookSlot> getSlots(RecipeEntryMapDuplication recipe, int recipeAmount, int xOffset, int yOffset) {
+        List<GuidebookSlot> recipeSlots = new ArrayList<>();
+
+        ItemStack initMap = new ItemStack(Items.MAP, 1, 1);
+        initMap.getData().putBoolean("initialized", true);
+        ItemStack initMapX2 = new ItemStack(initMap);
+        initMapX2.stackSize = 2;
+        RecipeSymbol[] symbols = {new RecipeSymbol(initMap), new RecipeSymbol(Items.MAP.getDefaultStack()), null, null, new RecipeSymbol(initMapX2)};
+
+        for (int i = 0; i < 4; i++) {
+            int x = 13 + 18 * (i % 2) + xOffset;
+            int y = 10 + 18 * ((i / 2) + recipeAmount * 3) + yOffset;
+            recipeSlots.add(new GuidebookSlot(i, x, y, symbols[i], false, recipe));
+        }
+
+        int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-3).y) / 2;
+        recipeSlots.add(new GuidebookSlot(symbols.length - 1, 81 + xOffset, centerY, symbols[4], false, recipe).setAsOutput());
+        return recipeSlots;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/RecipeDisplayAdapter.java b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/RecipeDisplayAdapter.java
new file mode 100644
index 000000000..fe2c09c79
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/RecipeDisplayAdapter.java
@@ -0,0 +1,10 @@
+package net.minecraft.client.gui.guidebook.crafting.displays;
+
+import net.minecraft.client.gui.guidebook.GuidebookSlot;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCrafting;
+
+import java.util.List;
+
+public interface RecipeDisplayAdapter<T extends RecipeEntryCrafting<?, ?>> {
+    List<GuidebookSlot> getSlots(T recipe, int recipeAmount, int xOffset, int yOffset);
+}
